/* USER CODE BEGIN Header */
/* you can remove the copyright */

/*
 *  Copyright 2020-2024 Yuntu Microelectronics co.,ltd
 *  All rights reserved.
 * 
 *  YUNTU Confidential. This software is owned or controlled by YUNTU and may only be
 *  used strictly in accordance with the applicable license terms. By expressly
 *  accepting such terms or by downloading, installing, activating and/or otherwise
 *  using the software, you are agreeing that you have read, and that you agree to
 *  comply with and are bound by, such license terms. If you do not agree to be
 *  bound by the applicable license terms, then you may not retain, install,
 *  activate or otherwise use the software. The production use license in
 *  Section 2.3 is expressly granted for this software.
 * 
 * @file main.c
 * @brief 
 * 
 */

/* USER CODE END Header */
#include "sdk_project_config.h"
/* Includes ------------------------------------------------------------------*/

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
#define CAPTURE_INST (0)
#define CAPTURE_CHAN (0)
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
/* USER CODE BEGIN PV */
/* USER CODE END PV */

/* Private function declare --------------------------------------------------*/
/* USER CODE BEGIN PFDC */
uint32_t ch0_cnt = 0;
uint32_t ch1_cnt = 0;
/* USER CODE END PFDC */
static void Board_Init(void);

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void eTMR_CH0_Callback(ic_event_t event, void *userData)
{
    eTMR_DRV_ClearInputCaptureComplete(0, 0); 
    ch0_cnt = ETMR_CM_Config0_State.measurementNegPulseCnt[0];
    PRINTF("The ch0 neg count is %d.\n\r", ch0_cnt);
    
}

void eTMR_CH1_Callback(ic_event_t event, void *userData)
{
    eTMR_DRV_ClearInputCaptureComplete(0, 1);
    ch1_cnt = ETMR_CM_Config0_State.measurementNegPulseCnt[1];
    PRINTF("The ch1 neg count is %d.\n\r", ch1_cnt);
    
}
/* USER CODE END 0 */


/**
 * @brief  The application entry point.
 * @retval int
 */
int main(void)
{
    /* USER CODE BEGIN 1 */
    /* USER CODE END 1 */ 
    Board_Init();
    /* USER CODE BEGIN 2 */

    /* Note: If enable channel interrupt, when rising/falling edge arrives, flag will set,
     *       it will enter interrupt, the counter value is 0 at this time because counter 
     *       is not enable. So it is necessary to enable counter first.
     */
    eTMR_DRV_Enable(0);
    OSIF_TimeDelay(1);
    /* Enable channel 0 interrupt */
    //eTMR_DRV_EnableInterrupts(0, 0x1|0x2);

    /* USER CODE END 2 */

    /* Infinite loop */
    /* USER CODE BEGIN WHILE */
    while (1)
    {
        // if (eTMR_DRV_GetInputCaptureComplete(CAPTURE_INST, CAPTURE_CHAN))
        // {
        //     PRINTF("The pulse count is %d.\n", ETMR_CM_Config0_State.measurementPosPulseCnt[CAPTURE_CHAN]);
        //     eTMR_DRV_ClearInputCaptureComplete(CAPTURE_INST, CAPTURE_CHAN);
        //     break;
        // }
        /* USER CODE END WHILE */
        /* USER CODE BEGIN 3 */
    }
    /* USER CODE END 3 */
}

static void Board_Init(void)
{
    CLOCK_SYS_Init(g_clockManConfigsArr,CLOCK_MANAGER_CONFIG_CNT,g_clockManCallbacksArr,CLOCK_MANAGER_CALLBACK_CNT);
    CLOCK_SYS_UpdateConfiguration(CLOCK_MANAGER_ACTIVE_INDEX,CLOCK_MANAGER_POLICY_AGREEMENT);
    PINS_DRV_Init(NUM_OF_CONFIGURED_PINS0,g_pin_mux_InitConfigArr0);
    eTMR_DRV_Init(0,&ETMR_CM_Config0,&ETMR_CM_Config0_State);
    eTMR_DRV_InitInputCapture(0,&ETMR_IC_Config0);
    UTILITY_PRINT_Init();
    eTMR_DRV_Init(1,&ETMR_CM_Config1,&ETMR_CM_Config1_State);
    eTMR_DRV_InitPwm(1,&ETMR_PWM_Config0);
    eTMR_DRV_Enable(1);
}

/* USER CODE BEGIN 4 */
/* USER CODE END 4 */
